%Now we need to calculate equilibrium form these calibrated parameters.
%This gives us some objects necessary to plot, and gives gamma, necessary
%to run the counterfactuals
tqt = theta*q(theta,eta);
% nu_n = nu_N;
% nu_b = nu_B;
% tau = 0.6; 
% b = 0.469;

Nchi = 100; %Number of grid points
CHI1 = linspace(1e-4,1.5,Nchi-10);
CHI2 = linspace(2,10,10);
CHI = [CHI1 CHI2]; %Grid for chi values, make it finer at the lower end, where all the action is

W1 = zeros(1,Nchi);
W2 = W1;
W3 = W1;
S1 = W1;
S2 = W1;
S3 = W1;
W_ind = W1;
W = W1;

for i = 1:Nchi
    chi = CHI(i);
    [woptc1,s1opt] = wagechi1(chi,theta,b,d,r,nu_b,nu_n,phi,tau,cb,cn,c,beta,lambda,sigma,eta,tauL,y,alow);
    W1(i) = woptc1(1);
    S1(i) = -s1opt; %Value of the surplus at optimal wage
    
    [woptc2,s2opt] = wagechi2(chi,theta,b,d,r,nu_b,phi,tau,cb,c,beta,lambda,sigma,eta,tauL,y,alow);
    W2(i) = woptc2(1);
    S2(i) = -s2opt;
    
    [woptc3,s3opt] = wagechi3(theta,d,r,beta,lambda,eta,tauL,y);
    W3(i) = woptc3(1);
    S3(i) = -s3opt;
    
    [~,Smi] = max([s1opt s2opt s3opt]);
    W_ind(i) = Smi;
    if Smi==1
        W(i) = woptc1;
    else
        if Smi==2
            W(i) = woptc2(1);
        else
            W(i) = woptc3(1);
        end
    end
end
%Now, given these wages, have to determine what values of chi will have
%different wages via the bargaining process
%First have to figure out what the current cut-offs are (i.e. current
%decisions, given these wages
TAU1 = tau*((b*W1)/tqt);
TAU2 = tau*((b*W2)/tqt);
UN1 = (b*W1-d)/(r+tqt); %Given w this is the difference between collecting and non-collecting value functions
aN = (1/nu_n)*log((nu_n*UN1)./CHI);
aN(aN<alow) = alow;
aN(aN>50) = 50;
sN = exp(-nu_n*aN);
pN = ((sN.*TAU1)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
pN(pN>1)=1; %Make sure the probability does not exceed 1
aB = (1/nu_b)*log((nu_b*UN1)./CHI);
aB(aB<alow) = alow;
sB = exp(-nu_b*aB);
pB = ((sB.*TAU1)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
pB(pB>1)=1; %Make sure the probability does not exceed 1
UN2 = (b*W2-d)/(r+tqt); %Update the U minus N difference with the new wage
aN2 = (1/nu_n)*log((nu_n*UN2)./CHI);
aN2(aN2<alow) = alow;
aN2(aN2>50) = 50;
sN2 = exp(-nu_n*aN2);
pN2 = ((sN2.*TAU2)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
pN2(pN2>1)=1; %Make sure the probability does not exceed 1
aB2 = (1/nu_b)*log((nu_b*UN2)./CHI);
aB2(aB2<alow) = alow;
sB2 = exp(-nu_b*aB2);
pB2 = ((sB2.*TAU2)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
pB2(pB2>1)=1; %Make sure the probability does not exceed 1
%Set these for later
pB0 = pB;
pN0 = pN;
pB20 = pB2;
pN20 = pN2;
aB0 = aB;
aB20 = aB2;
aN0 = aN;
aN20 = aN2;
sN0 = sN;

%Now given these decisions, find cut-offs
%HERE, SHOULD HAVE A FINER GRID TO FIND CUT-OFFS
% CB = -TAU2+pB.*sB.*TAU2-pB.^2; 
% CN = -TAU1+pN.*sN.*TAU1-pN.^2;
% CB2 = -TAU2+pB2.*sB2.*TAU2-c*pB2.^cb;
% CN2 = -TAU2+pN2.*sN2.*TAU2-pN2.^cn;
FC_N = (lambda*(TAU1.*(1-pN.*sN)+(c.*pN).^2))*((1-(sigma*lambda)/(r+lambda+sigma)));
chiN_func = FC_N+CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
CHIF = linspace(CHI(1),CHI(Nchi),100000); %Make a much finer grid for CHI
chiN_funcF = pchip(CHI,chiN_func,CHIF);
chiN_iF = find(chiN_funcF<=0,1,'last');
chiN = CHIF(chiN_iF);
chiN_i = find(CHI<=chiN,1,'last');
%Then find the orginal chiN, and this will tell us what range to find new
%wages in
chiN_func0 = CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
chiN_func0F = pchip(CHI,chiN_func0,CHIF);
chiN_iF0 = find(chiN_func0F<=0,1,'last');
chiN0 = CHIF(chiN_iF0);
chiN_i0 = find(CHI<=chiN0,1,'last');
%Now for chiB
FC_B = (lambda*(TAU2.*(1-pB2.*sB2)+(c.*pB2).^2))*(((sigma*lambda)/(r+lambda+sigma)));
chiB_func = FC_B+CHI.*(phi+pB2.*aB2)-UN2.*(1-pB2.*sB2);
chiB_funcF = pchip(CHI,chiB_func,CHIF);
chiB_iF = find(chiB_funcF<=0,1,'last');
chiB = CHIF(chiB_iF);
chiB_i = find(CHI<=chiB,1,'last');
chiB_func0 = CHI.*(phi+pB2.*aB2)-UN1.*(1-pB2.*sB2);
chiB_func0F = pchip(CHI,chiB_func0,CHIF);
chiB_iF0 = find(chiB_func0F<=0,1,'last');
chiB0 = CHIF(chiB_iF0);
chiB_i0 = find(CHI<=chiB0,1,'last');
pN(chiN_i+1:Nchi) = 0;
sN(chiN_i+1:Nchi) = 0; %This is necessary for an integral below
pB(1:chiN_i) = pB(1:chiN_i);
pB(chiN_i+1:Nchi) = pB2(chiN_i+1:Nchi);
aB(1:chiN_i) = aB(1:chiN_i);
aB(chiN_i+1:Nchi) = aB2(chiN_i+1:Nchi);
sB(1:chiN_i) = sB(1:chiN_i);
sB(chiN_i+1:Nchi) = sB2(chiN_i+1:Nchi);

%Now we can compute some integrals that are needed to find the flows
if sigmachi==0
    fxn = expcdf(chiN,muchi);
    fxb = expcdf(chiB,muchi);
else
    fxn = logncdf(chiN,muchi,sigmachi); %Fraction with chi below chiN
    fxb = logncdf(chiB,muchi,sigmachi); %Fraction with chi below chiB
end
pp_pnsn = pchip(CHI,(1-pN.*sN).*fdist(CHI,muchi,sigmachi));
FXN = integral(@(x)ppval(pp_pnsn,x),0,chiN);
pp_pbsb = pchip(CHI,(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
FXB = integral(@(x)ppval(pp_pbsb,x),0,chiB);
tq = theta*q(theta,eta);
ne_B = nE_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
ne_N = nN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
% nu_B = nuB_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
% nu_N = nuN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
%Make a vector of the nuBs
NU_B = ((lambda*fdist(CHI,muchi,sigmachi))/((sigma+lambda)*(lambda+tqt))).*(lambda*(1-pN.*sN)+sigma*(1-pB.*sB)); %Vector of unemployed collectors, for each chi
pp_nub = pchip(CHI,NU_B);
nu_B = integral(@(x)ppval(pp_nub,x),0,chiB);
nu_N = 1-ne_B-ne_N-nu_B;
pp_dn = pchip(CHI,(pN.*sN).*fdist(CHI,muchi,sigmachi)); %This is probabiltiy of being denied
DXN = integral(@(x)ppval(pp_dn,x),0,chiN);
pp_db = pchip(CHI,(pB.*sB).*fdist(CHI,muchi,sigmachi));
DXB = integral(@(x)ppval(pp_db,x),0,chiB);
ipdr = (ne_B*DXB)/(ne_B*DXB+ne_N*DXN); %This is the improper denial rate: fraction that apply * probability of successful review
fraud = (FXN*ne_N)/nu_B;
pp_pb = pchip(CHI,pB.*fdist(CHI,muchi,sigmachi));
PB = integral(@(x)ppval(pp_pb,x),0,chiB);
pp_pn = pchip(CHI,pN.*fdist(CHI,muchi,sigmachi));
PN = integral(@(x)ppval(pp_pn,x),0,chiN);
challenged = DXB/fxb + DXN/fxn; %Average probability of being denied...should be 70% to match data
%Calculate the total cost to the economy of applying for UI benefits
%For non-eligible
pp_pncost = pchip(CHI,pN.*aN.*fdist(CHI,muchi,sigmachi));
PN_cost = (1/expcdf(chiB,muchi))*integral(@(x)ppval(pp_pncost,x),0,chiN);
pp_pbcost = pchip(CHI,pB.*aB.*fdist(CHI,muchi,sigmachi));
PB_cost = (1/expcdf(chiB,muchi))*integral(@(x)ppval(pp_pbcost,x),0,chiB);
%What is unemployment and take-up rates
u_rate = nu_B+nu_N;
duration = 1/tqt;
tu_rate3 = ((1-u_rate)*nu_B)/(u_rate*ne_B);
%Create a distribution of UI collection costs
%A simple method
mu_cdf = expcdf(CHI(1:chiB_i),muchi);
sum1 = mu_cdf(1);
SUM_ALL = zeros(1,length(mu_cdf));
SUM_ALL(1) = 100*sum1;
for i = 2:length(mu_cdf)
    sum1 = sum1+100*(mu_cdf(i)-mu_cdf(i-1));
    SUM_ALL(i) = sum1;
end

p5 = [0.2 0.4 0.6 0.8];
CHI_dist = zeros(1,5);
for i = 2:5
    num_if = p5(i-1)*SUM_ALL(length(SUM_ALL));
    c_if = find(SUM_ALL<=num_if,1,'last'); %This is the CHI gridpoint coresponding to the bottom 20% of chi, conditional on collecting UI
    CHI_dist(i) = CHI(c_if);
end

COST_A_dist = zeros(1,5);
COST_B_dist = zeros(1,5);
for i = 1:4
    if i>1
        pn_part = (expcdf(chiB)/mu_cdf(i))*integral(@(x)ppval(pp_pncost,x),CHI_dist(i),CHI_dist(i+1));
    else
        pn_part = (expcdf(chiB)/mu_cdf(i))*integral(@(x)ppval(pp_pncost,x),0,chiN);
    end
    pb_part = (expcdf(chiB)/mu_cdf(i))*integral(@(x)ppval(pp_pbcost,x),CHI_dist(i),CHI_dist(i+1));
    tot_cost = 100*(pn_part+pb_part)/(phi+pn_part+pb_part);
    COST_A_dist(i) = tot_cost;
    COST_B_dist(i) = 100*(pb_part)/(phi+pn_part+pb_part);
end
pb_part = (expcdf(chiB)/mu_cdf(5))*integral(@(x)ppval(pp_pbcost,x),CHI_dist(5),chiB);
tot_cost = 100*(pb_part)/(phi+pb_part);
COST_A_dist(5) = tot_cost;
COST_B_dist(5) = tot_cost;

%Now we also have to determine UI expenditures, and calculate the tauL
%necessary to balance the budget
pp_coll1 = pchip(CHI,TAU1.*(1-pN.*sN).*fdist(CHI,muchi,sigmachi)); 
pp_coll2 = pchip(CHI,TAU2.*(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
COLL_N = integral(@(x)ppval(pp_coll1,x),0,chiN);
COLL_B = integral(@(x)ppval(pp_coll2,x),0,chiB);
COLL = lambda*(ne_N*COLL_N+ne_B*COLL_B); %This should be the total collections of benefits
%Now for current UI expenditures
pp_expend1 = pchip(CHI,NU_B.*(b*W1));
pp_expend2 = pchip(CHI,NU_B.*(b*W2));
EXP1 = integral(@(x)ppval(pp_expend1,x),0,chiN);
EXP2 = integral(@(x)ppval(pp_expend2,x),chiN,chiB);
EXP = EXP1+EXP2;
%Now can calculate tauL
tauL = (EXP-COLL)/(1-u_rate); %This puts this into the loop, hopefully it works :)

%Now we also need to calculate the market clearing gamma, given the
%targeted theta
%First for chi between 0 and chiN
CB = -TAU1+pB.*sB.*TAU1-(c.*pB).^2; 
CN = -TAU1+pN.*sN.*TAU1-(c.*pN).^2;
CB2 = -TAU2+pB2.*sB2.*TAU2-(c*pB2).^cb;
CN2 = -TAU2+pN2.*sN2.*TAU2-(c.*pN2).^cn;
JBmJN = (lambda*(CB-CN))/(r+lambda);
J1 = (1/(r+lambda))*(y-W1-tauL+lambda*CN+((sigma*lambda*(CB-CN))/(r+lambda+sigma)));
pp_J1 = pchip(CHI,J1.*fdist(CHI,muchi,sigmachi));
intJ1 = integral(@(x)ppval(pp_J1,x),0,chiN);
J2 = (1/(r+lambda))*(y-W2-tauL+((sigma*lambda*CB2)/(r+lambda+sigma)));
pp_J2 = pchip(CHI,J2.*fdist(CHI,muchi,sigmachi));
intJ2 = integral(@(x)ppval(pp_J2,x),chiN,chiB);
J3 = ((1/(r+lambda))*(y-W3(1)-tauL)).*fdist(CHI,muchi,sigmachi);
pp_J3 = pchip(CHI,J3);
intJ3 = integral(@(x)ppval(pp_J3,x),chiB,CHI(Nchi));
gamma = q(theta,eta)*(intJ1+intJ2+intJ3); %Given tqt, what gamma is necessary to satisfy the free-entry condition

%Then construct the tables
totcostCont = phi+PB_cost+PN_cost;
phiCont = 100*(phi/totcostCont);
PiCont = 100*((PB_cost+PN_cost)/totcostCont);
IPDCont = 100*(PB_cost/totcostCont);
Tab6 = [round(phiCont) 100; round(PiCont) round(100*(PB_cost+PN_cost)/phi); round(IPDCont) round(100*PB_cost/phi)];

Tab7 = [COST_A_dist' COST_B_dist'];
% pB0 = pB;
% pN0 = pN;
% pB20 = pB2;
% pN20 = pN2;
% aB0 = aB;
% aB20 = aB2;
% aN0 = aN;
% aN20 = aN2;
