%Run some comparative statics
%First with respect to tau
Nt = 5;
TAUV = linspace(0,1,Nt);
URATEt = zeros(1,Nt); %Holding vector for results on unemployment rate
DURt = zeros(1,Nt); %Holding vector for results on duration
TURt = zeros(1,Nt); %Holding vector for results on take-up rate
IPDRt = zeros(1,Nt); %Holding vector for results on improper denials
FRAUDt = zeros(1,Nt); %Holding vector for results on fraud rate
TAULt = zeros(1,Nt); %Holding vector for tauL, want to check where it is at
WELt = zeros(1,Nt); %Holding vector for welfare
% b = 0.469; %Return this to normal
comp_stats_tag = 1;

for j = 1:Nt
    tau = TAUV(j); %Set tau
%     TAUV(25) = 0.49;
    equil_for_comp_stats_Rev2 %This runs equilibrium, holding nu_N, nu_B, and gamma as fixed in initial equilibrium
    URATEt(j) = u_rate; 
    DURt(j) = duration; 
    TURt(j) = tu_rate; 
    IPDRt(j) = ipdr; 
    FRAUDt(j) = fraud;
    TAULt(j) = tauL;
    WELt(j) = Welfare;
end
%Now we need to change the UI replacement rate
% tauL = 0.0086; %Get back to original numbers
tau = 0.6; %Reset this
% Br = linspace(0.1,0.9,Nt); 
Br1 = linspace(0.1,0.469,3);
step = Br1(2)-Br1(1);
Br2  = linspace(0.469+step,0.469+step*2,2);
Br = [Br1 Br2];
Nt = length(Br);
% Br(38) = 0.63; %For some reason theta solver stalls, so getting it out of a bad loop here
URATEb = zeros(1,Nt); %Holding vector for results on unemployment rate
DURb = zeros(1,Nt); %Holding vector for results on duration
TURb = zeros(1,Nt); %Holding vector for results on take-up rate
IPDRb = zeros(1,Nt); %Holding vector for results on improper denials
FRAUDb = zeros(1,Nt); %Holding vector for results on fraud rate
CHIB = zeros(1,Nt); %Holding vector for chiB
CHIN = zeros(1,Nt); %Holding vector for chiN
dnyB = zeros(1,Nt); %Holding vector for probability of being denied, eligible
dnyN = zeros(1,Nt); %Holding vector for probability of being denied, ineligible
WELb = zeros(1,Nt); %Holding vector for welfare
EXPb = zeros(1,Nt); %Holding vector for UI expenditures
NUBb = zeros(1,Nt); %Holding vector for number of unemployed collecting
NUNb = zeros(1,Nt); %Holding vector for number of unemployed not-collecting
NEBb = zeros(1,Nt); %Holding vector for number of employed, eligible
NENb = zeros(1,Nt); %Holding vector for number of employed, ineligible
FILEb = zeros(1,Nt); %Holding vector for number of people filing a claim

comp_stats_tag=1;

for j = 1:Nt
    b = Br(j); %This sets the replacement rate
    equil_for_comp_stats_Rev2 %This runs equilibrium, holding nu_N, nu_B, and gamma as fixed in initial equilibrium
    URATEb(j) = u_rate; 
    DURb(j) = duration; 
    TURb(j) = tu_rate; 
    IPDRb(j) = ipdr; 
    FRAUDb(j) = fraud;
    WELb(j) = Welfare;
end

%Now make finer grids for the plots
NtF = 100;
TAUVF = linspace(TAUV(1),TAUV(Nt),NtF);
DURtf = pchip(TAUV,DURt,TAUVF);
URATEtf = pchip(TAUV,URATEt,TAUVF);
TURtf = pchip(TAUV,TURt,TAUVF);
IPDRtf = pchip(TAUV,IPDRt,TAUVF);
FRAUDtf = pchip(TAUV,FRAUDt,TAUVF);
WELtf = pchip(TAUV,WELt,TAUVF);

comp_stats_Rev_FIXCOSTS_R2

BrF = linspace(Br(1),Br(Nt),NtF);
URATEbf = pchip(Br,URATEb,BrF);
URATEbFf = pchip(Br,URATEbF,BrF);
TURbf = pchip(Br,TURb,BrF);
TURbFf = pchip(Br,TURbF,BrF);
IPDRbf = pchip(Br,IPDRb,BrF);
IPDRbFf = pchip(Br,IPDRbF,BrF);
FRAUDbf = pchip(Br,FRAUDb,BrF);
FRAUDbFf = pchip(Br,FRAUDbF,BrF);

