function F = equil_stock_flows_RRv2R(theta,b,d,r,nu_b,nu_n,phi,tau,cb,cn,beta,lambda,sigma,eta,tauL,muchi,sigmachi,y,alow,c)

tqt = theta*q(theta,eta);

%Given theta, calculate chiB and chiN, which requires value function
%iteration
Nchi = 100; %Number of grid points
CHI1 = linspace(1e-4,1.5,Nchi-10);
CHI2 = linspace(2,10,10);
CHI = [CHI1 CHI2]; %Grid for chi values, make it finer at the lower end, where all the action is

W1 = zeros(1,Nchi);
W2 = W1;
W3 = W1;
S1 = W1;
S2 = W1;
S3 = W1;
W_ind = W1;
W = W1;
En1_opt = W1;
J1 = W1;
N1_opt = W1;

for i = 1:Nchi
    chi = CHI(i);
    [woptc1,s1opt] = wagechi1(chi,theta,b,d,r,nu_b,nu_n,phi,tau,cb,cn,c,beta,lambda,sigma,eta,tauL,y,alow);
    W1(i) = woptc1(1);
    S1(i) = -s1opt; %Value of the surplus at optimal wage
    
    [woptc2,s2opt] = wagechi2(chi,theta,b,d,r,nu_b,phi,tau,cb,c,beta,lambda,sigma,eta,tauL,y,alow);
    W2(i) = woptc2(1);
    S2(i) = -s2opt;
    
    [woptc3,s3opt] = wagechi3(theta,d,r,beta,lambda,eta,tauL,y);
    W3(i) = woptc3(1);
    S3(i) = -s3opt;
    
    [~,Smi] = max([s1opt s2opt s3opt]);
    W_ind(i) = Smi;
    if Smi==1
        W(i) = woptc1;
    else
        if Smi==2
            W(i) = woptc2(1);
        else
            W(i) = woptc3(1);
        end
    end
    
    %Here need to compute the worker's value functions at the optimal wage,
    %and the firm's value of a vacancy
    tau1 = tau*((b*W1(i))/tqt);
    UN = (b*W1(i)-d)/(r+tqt); %Given w this is the difference between collecting and non-collecting value functions
    aN = (1/nu_n)*log((nu_n*UN)./chi);
    aN(aN<alow) = alow;
    aN(aN>100) = 100;
    sN = exp(-nu_n*aN);
    pN = ((sN.*tau1)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
    pN(pN>1)=1; %Make sure the probability does not exceed 1
    aB = (1/nu_b)*log((nu_b*UN)./chi);
    aB(aB<alow) = alow;
    sB = exp(-nu_b*aB);
    pB = ((sB.*tau1)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
    pB(pB>1)=1; %Make sure the probability does not exceed 1
    En1_opt(i) = En1(aB,aN,b,chi,d,lambda,pB,pN,phi,r,sB,sN,sigma,tqt,W1(i));
    N1_opt(i) = N1(aB,aN,b,chi,d,lambda,pB,pN,phi,r,sB,sN,sigma,tqt,W1(i));
    
    %Also the firm's value function, J_n1(w)
%     CB1 = -tau1+pB.*sB.*tau1-c*pB.^cb;
%     CN1 = -tau1+pN.*sN.*tau1-c*pN.^cn; %These are the expected UI costs for firms, given their auditing probabilities
%     J1(i) = (1./(r+lambda))*(y-W1(i)-tauL+lambda.*CN1+((sigma*lambda.*(CB1-CN1))./(r+lambda)));
    J1(i) = jn1(c,cb,cn,lambda,pB,pN,r,sB,sN,sigma,tau,tauL,W1(i),y);
end
%Now, given these wages, have to determine what values of chi will have
%different wages via the bargaining process
%First have to figure out what the current cut-offs are (i.e. current
%decisions, given these wages
TAU1 = tau*((b*W1)/tqt);
TAU2 = tau*((b*W2)/tqt);
UN1 = (b*W1-d)/(r+tqt); %Given w this is the difference between collecting and non-collecting value functions
aN = (1/nu_n)*log((nu_n*UN1)./CHI);
aN(aN<alow) = alow;
aN(aN>50) = 50;
sN = exp(-nu_n*aN);
pN = ((sN.*TAU1)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
pN(pN>1)=1; %Make sure the probability does not exceed 1
aB = (1/nu_b)*log((nu_b*UN1)./CHI);
aB(aB<alow) = alow;
sB = exp(-nu_b*aB);
pB = ((sB.*TAU1)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
pB(pB>1)=1; %Make sure the probability does not exceed 1
UN2 = (b*W2-d)/(r+tqt); %Update the U minus N difference with the new wage
aN2 = (1/nu_n)*log((nu_n*UN2)./CHI);
aN2(aN2<alow) = alow;
aN2(aN2>50) = 50;
sN2 = exp(-nu_n*aN2);
pN2 = ((sN2.*TAU2)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
pN2(pN2>1)=1; %Make sure the probability does not exceed 1
aB2 = (1/nu_b)*log((nu_b*UN2)./CHI);
aB2(aB2<alow) = alow;
sB2 = exp(-nu_b*aB2);
pB2 = ((sB2.*TAU2)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
pB2(pB2>1)=1; %Make sure the probability does not exceed 1

%Now given these decisions, find cut-offs
%HERE, SHOULD HAVE A FINER GRID TO FIND CUT-OFFS
% CB = -TAU2+pB.*sB.*TAU2-pB.^2; 
% CN = -TAU1+pN.*sN.*TAU1-pN.^2;
% CB2 = -TAU2+pB2.*sB2.*TAU2-c*pB2.^cb;
% CN2 = -TAU2+pN2.*sN2.*TAU2-pN2.^cn;
FC_N = (lambda*(TAU1.*(1-pN.*sN)+(c.*pN).^2))*((1-(sigma*lambda)/(r+lambda+sigma)));
chiN_func = FC_N+CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
CHIF = linspace(CHI(1),CHI(Nchi),100000); %Make a much finer grid for CHI
chiN_funcF = pchip(CHI,chiN_func,CHIF);
chiN_iF = find(chiN_funcF<=0,1,'last');
chiN = CHIF(chiN_iF);
chiN_i = find(CHI<=chiN,1,'last');
%Then find the orginal chiN, and this will tell us what range to find new
%wages in
chiN_func0 = CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
chiN_func0F = pchip(CHI,chiN_func0,CHIF);
chiN_iF0 = find(chiN_func0F<=0,1,'last');
chiN0 = CHIF(chiN_iF0);
chiN_i0 = find(CHI<=chiN0,1,'last');
%Now for chiB
FC_B = (lambda*(TAU2.*(1-pB2.*sB2)+(c.*pB2).^2))*(((sigma*lambda)/(r+lambda+sigma)));
chiB_func = FC_B+CHI.*(phi+pB2.*aB2)-UN2.*(1-pB2.*sB2);
chiB_funcF = pchip(CHI,chiB_func,CHIF);
chiB_iF = find(chiB_funcF<=0,1,'last');
chiB = CHIF(chiB_iF);
chiB_i = find(CHI<=chiB,1,'last');
chiB_func0 = CHI.*(phi+pB2.*aB2)-UN1.*(1-pB2.*sB2);
chiB_func0F = pchip(CHI,chiB_func0,CHIF);
chiB_iF0 = find(chiB_func0F<=0,1,'last');
chiB0 = CHIF(chiB_iF0);
chiB_i0 = find(CHI<=chiB0,1,'last');
pN(chiN_i+1:Nchi) = 0;
sN(chiN_i+1:Nchi) = 0; %This is necessary for an integral below
pB(1:chiN_i) = pB(1:chiN_i);
pB(chiN_i+1:Nchi) = pB2(chiN_i+1:Nchi);
aB(1:chiN_i) = aB(1:chiN_i);
aB(chiN_i+1:Nchi) = aB2(chiN_i+1:Nchi);
sB(1:chiN_i) = sB(1:chiN_i);
sB(chiN_i+1:Nchi) = sB2(chiN_i+1:Nchi);

%Now we can compute some integrals that are needed to find the flows
if sigmachi==0
    fxn = expcdf(chiN,muchi);
    fxb = expcdf(chiB,muchi);
else
    fxn = logncdf(chiN,muchi,sigmachi); %Fraction with chi below chiN
    fxb = logncdf(chiB,muchi,sigmachi); %Fraction with chi below chiB
end
pp_pnsn = pchip(CHI,(1-pN.*sN).*fdist(CHI,muchi,sigmachi));
FXN = integral(@(x)ppval(pp_pnsn,x),0,chiN);
% FXN = (1-exp(-muchi*chiN));
pp_pbsb = pchip(CHI,(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
FXB = integral(@(x)ppval(pp_pbsb,x),0,chiB);
% keyboard
% FXB = 1-exp(-muchi*chiB); 
% FXN = 1-exp(-muchi*chiN);
tq = theta*q(theta,eta);
ne_B = nE_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
ne_N = nN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
% nu_B = nuB_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
% nu_N = nuN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
%Make a vector of the nuBs
NU_B = ((lambda*fdist(CHI,muchi,sigmachi))/((sigma+lambda)*(lambda+tqt))).*(lambda*(1-pN.*sN)+sigma*(1-pB.*sB)); %Vector of unemployed collectors, for each chi
pp_nub = pchip(CHI,NU_B);
nu_B = integral(@(x)ppval(pp_nub,x),0,chiB);
nu_N = 1-ne_B-ne_N-nu_B;
pp_dn = pchip(CHI,(pN.*sN).*fdist(CHI,muchi,sigmachi)); %This is probabiltiy of being denied
DXN = integral(@(x)ppval(pp_dn,x),0,chiN);
% DXN = pN*sN;
pp_db = pchip(CHI,(pB.*sB).*fdist(CHI,muchi,sigmachi));
DXB = integral(@(x)ppval(pp_db,x),0,chiB);
ipdr = (ne_B*DXB)/(ne_B*DXB+ne_N*DXN); %This is the improper denial rate: fraction that apply * probability of successful review
fraud = (FXN*ne_N)/nu_B;
% denial_rate = ((DXB*ne_B+DXN*ne_N))/nu_B;
pp_pb = pchip(CHI,pB.*fdist(CHI,muchi,sigmachi));
PB = integral(@(x)ppval(pp_pb,x),0,chiB);
pp_pn = pchip(CHI,pN.*fdist(CHI,muchi,sigmachi));
PN = integral(@(x)ppval(pp_pn,x),0,chiN);
% challenged = (PB*ne_B+PN*ne_N)/(fxb*ne_B+fxn*ne_N); %Percentage of claims that are challenged
challenged = DXB/fxb + DXN/fxn; %Average probability of being denied...should be 70% to match data
% challenged = PB+PN;
%Calculate the total cost to the economy of applying for UI benefits
%For non-eligible
pp_pncost = pchip(CHI,pN.*aN.*fdist(CHI,muchi,sigmachi));
PN_cost = integral(@(x)ppval(pp_pncost,x),0,chiN);
pp_pbcost = pchip(CHI,pB.*aB.*fdist(CHI,muchi,sigmachi));
PB_cost = integral(@(x)ppval(pp_pbcost,x),0,chiB);
%What is unemployment and take-up rates
u_rate = nu_B+nu_N;
duration = 1/tqt;
tu_rate3 = ((1-u_rate)*nu_B)/(u_rate*ne_B);

%Now we also have to determine UI expenditures, and calculate the tauL
%necessary to balance the budget
pp_coll1 = pchip(CHI,TAU1.*(1-pN.*sN).*fdist(CHI,muchi,sigmachi)); 
pp_coll2 = pchip(CHI,TAU2.*(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
COLL_N = integral(@(x)ppval(pp_coll1,x),0,chiN);
COLL_B = integral(@(x)ppval(pp_coll2,x),0,chiB);
COLL = lambda*(ne_N*COLL_N+ne_B*COLL_B); %This should be the total collections of benefits
%Now for current UI expenditures
pp_expend1 = pchip(CHI,NU_B.*(b*W1));
pp_expend2 = pchip(CHI,NU_B.*(b*W2));
EXP1 = integral(@(x)ppval(pp_expend1,x),0,chiN);
EXP2 = integral(@(x)ppval(pp_expend2,x),chiN,chiB);
EXP = EXP1+EXP2;
%Now can calculate tauL
tauL = (EXP-COLL)/(1-u_rate); %This puts this into the loop, hopefully it works :)

F = [tu_rate3 ipdr fraud u_rate challenged duration PN_cost PB_cost FXN FXB ne_B ne_N chiB chiN chiB0 chiN0 COLL EXP tauL];