
if comp_stats_tag==0 %Only load these parameters is running for the first time
    r = (1+0.04)^(1/12)-1; %We will go monthly
    eta = 0.5;
    dur_target = 22.36/4;
    theta_target = dur_target^(1/(eta-1)); %Just specifying this to hit target duration of 15
    theta = theta_target;
    tur_target = 0.734;
    y = 1; 
    b = 0.469; %0.887 0.876
    d = 0.0; %-0.25 %0.678 0.428
    beta = eta;
    urate_target = 0.0662;
    lambda = (urate_target*theta_target*q(theta_target,eta))/(1-urate_target);
    sigma = 1/6;
    cb = 2.0; %1.028; %0.00006; %This is a parameter for the firm, governing how costly it is to challenge a worker claim
    cn = 2.0;
    muchi = 1.0; %1.2%0.18
    % muchi = 4.8643; %0.056 %1/109; %1/459; %Parameter for distribution F(chi) was 1/109, then 1/234 for low d 1/281 for d = 0.34
    sigmachi = 0.0; %Variance of distribution (if using log-normal)
    tqt = theta*q(theta,eta);
    tau = 0.6;

    load PARAMR2
    nu_b = PARAMR2(1);
    nu_n = PARAMR2(2);
    phi =PARAMR2(3);
    gamma = PARAMR2(4);
    alow = PARAMR2(5);
    tauL = PARAMR2(6);
    c = PARAMR2(7);
end
 
%Here we need to find the equilibrium theta, given gamma
Ntheta = 20;
THETA = linspace(0.02,0.05,Ntheta);
thetaH = 0.06;
thetaL = 0.02;
 
Big_phi = zeros(1,Ntheta);
URATE = zeros(1,Ntheta);
DUR = zeros(1,Ntheta);
TUR = zeros(1,Ntheta);
FRAUD = zeros(1,Ntheta);
IPDR = zeros(1,Ntheta);
TAUL = zeros(1,Ntheta);
WEL = zeros(1,Ntheta);
CHIB = WEL;
CHIB0 = WEL;
CHIN = WEL;
CHIN0 = WEL;
for t = 1:Ntheta
    theta = THETA(t);
    diff_tau = 1;
    toler_tau = 1e-4;
    counter_tau = 1;
    while diff_tau>toler_tau
        tqt = theta*q(theta,eta);
        diff = 1;
        toler = 1e-6;
        counter_v = 1;
        %Given theta, calculate chiB and chiN, which requires value function
        %iteration
        Nchi = 100; %Number of grid points
        if phi>0
            CHI1 = linspace(1e-4,1.5,Nchi-10);
            CHI2 = linspace(2,10,10);
            CHI = [CHI1 CHI2]; %Grid for chi values, make it finer at the lower end, where all the action is
        else
            CHI = linspace(1e-4,15,100);
        end
        W1 = zeros(1,Nchi);
        W2 = W1;
        W3 = W1;
        S1 = W1;
        S2 = W1;
        S3 = W1;
        W_ind = W1;
        W = W1;
 
        for i = 1:Nchi
            chi = CHI(i);
            [woptc1,s1opt] = wagechi1(chi,theta,b,d,r,nu_b,nu_n,phi,tau,cb,cn,c,beta,lambda,sigma,eta,tauL,y,alow);
            W1(i) = woptc1(1);
            S1(i) = -s1opt; %Value of the surplus at optimal wage
 
            [woptc2,s2opt] = wagechi2(chi,theta,b,d,r,nu_b,phi,tau,cb,c,beta,lambda,sigma,eta,tauL,y,alow);
            W2(i) = woptc2(1);
            S2(i) = -s2opt;
 
            [woptc3,s3opt] = wagechi3(theta,d,r,beta,lambda,eta,tauL,y);
            W3(i) = woptc3(1);
            S3(i) = -s3opt;
 
            [~,Smi] = max([s1opt s2opt s3opt]);
            W_ind(i) = Smi;
            if Smi==1
                W(i) = woptc1;
            else
                if Smi==2
                    W(i) = woptc2(1);
                else
                    W(i) = woptc3(1);
                end
            end
        end
        %Now, given these wages, have to determine what values of chi will have
        %different wages via the bargaining process
        %First have to figure out what the current cut-offs are (i.e. current
        %decisions, given these wages
        TAU1 = tau*((b*W1)/tqt);
        TAU2 = tau*((b*W2)/tqt);
        UN1 = (b*W1-d)/(r+tqt); %Given w this is the difference between collecting and non-collecting value functions
        aN = (1/nu_n)*log((nu_n*UN1)./CHI);
        aN(aN<alow) = alow;
        aN(aN>50) = 50;
        sN = exp(-nu_n*aN);
        pN = ((sN.*TAU1)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
        pN(pN>1)=1; %Make sure the probability does not exceed 1
        aB = (1/nu_b)*log((nu_b*UN1)./CHI);
        aB(aB<alow) = alow;
        sB = exp(-nu_b*aB);
        pB = ((sB.*TAU1)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
        pB(pB>1)=1; %Make sure the probability does not exceed 1
        UN2 = (b*W2-d)/(r+tqt); %Update the U minus N difference with the new wage
        aN2 = (1/nu_n)*log((nu_n*UN2)./CHI);
        aN2(aN2<alow) = alow;
        aN2(aN2>50) = 50;
        sN2 = exp(-nu_n*aN2);
        pN2 = ((sN2.*TAU2)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
        pN2(pN2>1)=1; %Make sure the probability does not exceed 1
        aB2 = (1/nu_b)*log((nu_b*UN2)./CHI);
        aB2(aB2<alow) = alow;
        sB2 = exp(-nu_b*aB2);
        pB2 = ((sB2.*TAU2)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
        pB2(pB2>1)=1; %Make sure the probability does not exceed 1
        %Set these for later
        pB0 = pB;
        pN0 = pN;
        pB20 = pB2;
        pN20 = pN2;
        aB0 = aB;
        aB20 = aB2;
        aN0 = aN;
        aN20 = aN2;
 
        %Now given these decisions, find cut-offs
        FC_N = (lambda*(TAU1.*(1-pN.*sN)+(c.*pN).^2))*((1-(sigma*lambda)/(r+lambda+sigma)));
        chiN_func = FC_N+CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
        CHIF = linspace(CHI(1),CHI(Nchi),100000); %Make a much finer grid for CHI
        chiN_funcF = pchip(CHI,chiN_func,CHIF);
        chiN_iF = find(chiN_funcF<=0,1,'last');
        chiN = CHIF(chiN_iF);
        chiN_i = find(CHI<=chiN,1,'last');
        %Then find the orginal chiN, and this will tell us what range to find new
        %wages in
        chiN_func0 = CHI.*(phi+pN.*aN)-UN1.*(1-pN.*sN);
        chiN_func0F = pchip(CHI,chiN_func0,CHIF);
        chiN_iF0 = find(chiN_func0F<=0,1,'last');
        chiN0 = CHIF(chiN_iF0);
        chiN_i0 = find(CHI<=chiN0,1,'last');
        %Now for chiB
        FC_B = (lambda*(TAU2.*(1-pB2.*sB2)+(c.*pB2).^2))*(((sigma*lambda)/(r+lambda+sigma)));
        chiB_func = FC_B+CHI.*(phi+pB2.*aB2)-UN2.*(1-pB2.*sB2);
        chiB_funcF = pchip(CHI,chiB_func,CHIF);
        chiB_iF = find(chiB_funcF<=0,1,'last');
        chiB = CHIF(chiB_iF);
        chiB_i = find(CHI<=chiB,1,'last');
        chiB_func0 = CHI.*(phi+pB2.*aB2)-UN1.*(1-pB2.*sB2);
        chiB_func0F = pchip(CHI,chiB_func0,CHIF);
        chiB_iF0 = find(chiB_func0F<=0,1,'last');
        chiB0 = CHIF(chiB_iF0);
        chiB_i0 = find(CHI<=chiB0,1,'last');
        pN(chiN_i+1:Nchi) = 0;
        sN(chiN_i+1:Nchi) = 0; %This is necessary for an integral below
        pB(1:chiN_i) = pB(1:chiN_i);
        pB(chiN_i+1:Nchi) = pB2(chiN_i+1:Nchi);
        aB(1:chiN_i) = aB(1:chiN_i);
        aB(chiN_i+1:Nchi) = aB2(chiN_i+1:Nchi);
        sB(1:chiN_i) = sB(1:chiN_i);
        sB(chiN_i+1:Nchi) = sB2(chiN_i+1:Nchi);
 
        %Now we can compute some integrals that are needed to find the flows
        if sigmachi==0
            fxn = expcdf(chiN,muchi);
            fxb = expcdf(chiB,muchi);
        else
            fxn = logncdf(chiN,muchi,sigmachi); %Fraction with chi below chiN
            fxb = logncdf(chiB,muchi,sigmachi); %Fraction with chi below chiB
        end
        pp_pnsn = pchip(CHI,(1-pN.*sN).*fdist(CHI,muchi,sigmachi));
        FXN = integral(@(x)ppval(pp_pnsn,x),0,chiN);
        % FXN = (1-exp(-muchi*chiN));
        pp_pbsb = pchip(CHI,(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
        FXB = integral(@(x)ppval(pp_pbsb,x),0,chiB);
        tq = theta*q(theta,eta);
        ne_B = nE_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
        ne_N = nN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
        % nu_B = nuB_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
        % nu_N = nuN_1(y,b,d,r,beta,lambda,sigma,theta,eta,nu_b,nu_n,CHI,tau,tauL,FXB,FXN,tq);
        %Make a vector of the nuBs
        NU_B = ((lambda*fdist(CHI,muchi,sigmachi))/((sigma+lambda)*(lambda+tqt))).*(lambda*(1-pN.*sN)+sigma*(1-pB.*sB)); %Vector of unemployed collectors, for each chi
        pp_nub = pchip(CHI,NU_B);
        nu_B = integral(@(x)ppval(pp_nub,x),0,chiB);
        nu_N = 1-ne_B-ne_N-nu_B;
        pp_dn = pchip(CHI,(pN.*sN).*fdist(CHI,muchi,sigmachi)); %This is probabiltiy of being denied
        DXN = integral(@(x)ppval(pp_dn,x),0,chiN);
        % DXN = pN*sN;
        pp_db = pchip(CHI,(pB.*sB).*fdist(CHI,muchi,sigmachi));
        DXB = integral(@(x)ppval(pp_db,x),0,chiB);
        ipdr = (ne_B*DXB)/(ne_B*DXB+ne_N*DXN); %This is the improper denial rate: fraction that apply * probability of successful review
        fraud = (FXN*ne_N)/nu_B;
        % denial_rate = ((DXB*ne_B+DXN*ne_N))/nu_B;
        pp_pb = pchip(CHI,pB.*fdist(CHI,muchi,sigmachi));
        PB = integral(@(x)ppval(pp_pb,x),0,chiB);
        pp_pn = pchip(CHI,pN.*fdist(CHI,muchi,sigmachi));
        PN = integral(@(x)ppval(pp_pn,x),0,chiN);
        % challenged = (PB*ne_B+PN*ne_N)/(fxb*ne_B+fxn*ne_N); %Percentage of claims that are challenged
        challenged = DXB/fxb + DXN/fxn; %Average probability of being denied...should be 70% to match data
        % challenged = PB+PN;
        %Calculate the total cost to the economy of applying for UI benefits
        %For non-eligible
        pp_pncost = pchip(CHI,pN.*aN.*fdist(CHI,muchi,sigmachi));
        PN_cost = integral(@(x)ppval(pp_pncost,x),0,chiN);
        pp_pbcost = pchip(CHI,pB.*aB.*fdist(CHI,muchi,sigmachi));
        PB_cost = integral(@(x)ppval(pp_pbcost,x),0,chiB);
        %What is unemployment and take-up rates
        u_rate = nu_B+nu_N;
        duration = 1/tqt;
        tu_rate3 = ((1-u_rate)*nu_B)/(u_rate*ne_B);
 
        %Now we also need to calculate the market clearing gamma, given the
        %targeted theta
        %First for chi between 0 and chiN
        CB = -TAU1+pB.*sB.*TAU1-(c.*pB).^2; 
        CN = -TAU1+pN.*sN.*TAU1-(c.*pN).^2;
        CB2 = -TAU2+pB2.*sB2.*TAU2-(c.*pB2).^cb;
        CN2 = -TAU2+pN2.*sN2.*TAU2-(c.*pN2).^cn;
        JBmJN = (lambda*(CB-CN))/(r+lambda);
        J1 = (1/(r+lambda))*(y-W1-tauL+lambda*CN+((sigma*lambda*(CB-CN))/(r+lambda+sigma)));
        pp_J1 = pchip(CHI,J1.*fdist(CHI,muchi,sigmachi));
        intJ1 = integral(@(x)ppval(pp_J1,x),0,chiN);
        J2 = (1/(r+lambda))*(y-W2-tauL+((sigma*lambda*CB2)/(r+lambda+sigma)));
        pp_J2 = pchip(CHI,J2.*fdist(CHI,muchi,sigmachi));
        intJ2 = integral(@(x)ppval(pp_J2,x),chiN,chiB);
        J3 = ((1/(r+lambda))*(y-W3(1)-tauL)).*fdist(CHI,muchi,sigmachi);
        pp_J3 = pchip(CHI,J3);
        intJ3 = integral(@(x)ppval(pp_J3,x),chiB,CHI(Nchi));
        big_phi = gamma/(q(theta,eta)) - (intJ1+intJ2+intJ3); %Given tqt, what gamma is necessary to satisfy the free-entry condition
        %Now we also have to determine UI expenditures, and calculate the tauL
        %necessary to balance the budget
        %Now we also have to determine UI expenditures, and calculate the tauL
        %necessary to balance the budget
        pp_coll1 = pchip(CHI,TAU1.*(1-pN.*sN).*fdist(CHI,muchi,sigmachi)); 
        pp_coll2 = pchip(CHI,TAU2.*(1-pB.*sB).*fdist(CHI,muchi,sigmachi));
        COLL_N = integral(@(x)ppval(pp_coll1,x),0,chiN);
        COLL_B = integral(@(x)ppval(pp_coll2,x),0,chiB);
        COLL = lambda*(ne_N*COLL_N+ne_B*COLL_B); %This should be the total collections of benefits
        %Now for current UI expenditures
        pp_expend1 = pchip(CHI,NU_B.*(b*W1));
        pp_expend2 = pchip(CHI,NU_B.*(b*W2));
        EXP1 = integral(@(x)ppval(pp_expend1,x),0,chiN);
        EXP2 = integral(@(x)ppval(pp_expend2,x),chiN,chiB);
        EXP = EXP1+EXP2;
        %Now can calculate tauL
        tauL_new = (EXP-COLL)/(1-u_rate); %This puts this into the loop, hopefully it works :)
        %Now can calculate tauL
%         tauL_new = EXP-COLL;
    %     tauL_new = (EXP-COLL)/(1-u_rate);
        diff_tau = abs(tauL-tauL_new);
    %     display(diff_tau)
        tauL = (tauL+tauL_new)/2;
        counter_tau = counter_tau+1;
        if counter_tau>50
            diff_tau = toler_tau;
            disp('There is an issue with tauL convergence')
        end
    end
    Big_phi(t) = big_phi;
    URATE(t) = u_rate;
    DUR(t) = duration;
    TUR(t) = tu_rate3;
    FRAUD(t) = fraud;
    if isnan(ipdr)==1
        ipdr = 0;
    else
        IPDR(t) = ipdr;
    end
    TAUL(t) = tauL;
    % keyboard
    %Some average wages
    pp_avgw1 = pchip(CHI,W1.*fdist(CHI,muchi,sigmachi));
    AVG_W1 = integral(@(x)ppval(pp_avgw1,x),0,chiN)/fxn;
    pp_avgw2 = pchip(CHI,W2.*fdist(CHI,muchi,sigmachi));
    AVG_W2 = integral(@(x)ppval(pp_avgw2,x),chiN,chiB)/(fxb-fxn);
    AVG_WAGE = integral(@(x)ppval(pp_avgw1,x),0,chiN)+integral(@(x)ppval(pp_avgw2,x),chiN,chiB)+(1-fxb)*W3(1);
 
    %Now look at welfare
    CBW = [CB(1:chiN_i) CB2(chiN_i+1:Nchi)];
    frac_E = ne_B/(1-u_rate);
    frac_N = ne_N/(1-u_rate);
  
    pp_intwB = pchip(CHI,NU_B.*(-pB.*aB.*CHI-phi*CHI));
    INTWB = integral(@(x)ppval(pp_intwB,x),0,chiB);
    pp_intwN = pchip(CHI,(-pN.*aN.*CHI-phi*CHI).*NU_B);
    INTWN = integral(@(x)ppval(pp_intwN,x),0,chiN);
    Welfare = (1-u_rate)*(y)+frac_E*INTWB+frac_N*INTWN-theta*u_rate*gamma;
  
    W0 = Welfare;
    WEL(t) = W0;
end
%Now make Big_phi finer
TF = linspace(THETA(1),THETA(Ntheta),100000);
BPF = pchip(THETA,Big_phi,TF);
ti = find(BPF>=0,1,'first');
theta = TF(ti);
URF = pchip(THETA,URATE,TF);
u_rate = URF(ti);
DURF = pchip(THETA,DUR,TF);
duration = DURF(ti);
TURF = pchip(THETA,TUR,TF);
tu_rate = TURF(ti);
FRAUDF = pchip(THETA,FRAUD,TF);
fraud = FRAUDF(ti);
IPDRF = pchip(THETA,IPDR,TF);
ipdr = IPDRF(ti);
TULF = pchip(THETA,TAUL,TF);
tauL = TULF(ti);
WELF = pchip(THETA,WEL,TF);
Welfare = WELF(ti);
% Welfare = F(18);
CHIBF = pchip(THETA,CHIB,TF);
CHIB0F = pchip(THETA,CHIB0,TF);
CHINF = pchip(THETA,CHIN,TF);
CHIN0F = pchip(THETA,CHIN0,TF);
chiB = CHIBF(ti);
chiN = CHINF(ti);
chiB0 = CHIB0F(ti);
chiN0 = CHIN0F(ti);


%Generate elasticities for Tables 5 and 8
b2 = 0.5; %Increase the replacement rate
F2 = equil_stock_flows_RRv2R(theta,b2,d,r,nu_b,nu_n,phi,tau,cb,cn,beta,lambda,sigma,eta,tauL,muchi,sigmachi,y,alow,c);
tu_rate2 = F2(1);
elasticity_b = ((tu_rate2-tu_rate)/(tu_rate))/((b2-b)/b);
elasticity_target_b = 0.668*(0.45/0.73); %This represents the regression elasticity, was 0.65?
theta2 = theta*0.9; %Decrease theta to increase duration
F3 = equil_stock_flows_RRv2R(theta2,b,d,r,nu_b,nu_n,phi,tau,cb,cn,beta,lambda,sigma,eta,tauL,muchi,sigmachi,y,alow,c);
tu_rate3 = F3(1);
elasticity_dur = ((tu_rate3-tu_rate)/(tu_rate))/((F3(6)-duration)/duration); %Model elasticity with respect to duration
elasticity_target_dur = 0.00448*(22.36/0.73); %Was 0.444
F4 = equil_stock_flows_RRv2R(theta,b,d,r,nu_b*1.5,nu_n,phi,tau,cb,cn,beta,lambda,sigma,eta,tauL,muchi,sigmachi,y,alow,c);
tu_rate4 = F4(1);
ipdr4 = F4(2);
elasticity_ipdr = ((tu_rate4-tu_rate)/(tu_rate))/((ipdr4-ipdr)/ipdr);
elasticity_target_ipdr = -0.42*(0.1/0.73);   %-0.374*(0.1/0.73);
F5 = equil_stock_flows_RRv2R(theta,b,d,r,nu_b,nu_n,phi*0.9,tau,cb,cn,beta,lambda,sigma,eta,tauL,muchi,sigmachi,y,alow,c);
tu_rate5 = F5(1);
elasticity_phi = ((tu_rate5-tu_rate)/(tu_rate))/((phi*(1-0.9))/phi);

%Generate Table 5
Tab5 = [100*u_rate 6.62;duration 5.59;100*tu_rate 73.4; 100*ipdr 10;100*fraud 3.30;elasticity_ipdr elasticity_target_ipdr];

%Generate Table 8
Tab8 = [elasticity_b elasticity_target_b;elasticity_dur elasticity_target_dur;elasticity_phi NaN];