%This function calculates wage, w1 (always collect) and thus value function for a given chi
function [woptc1,s1opt] = wagechi1FC(chi,theta,b,d,r,pB,pN,aB,aN,nu_n,nu_b,phi,tau,cb,cn,c,beta,lambda,sigma,eta,tauL,y)

options = optimoptions('fmincon','Display','off');
x0 = 0.5; %Initial guess for the wage
[woptc1,s1opt] = fmincon(@wagefunc,x0,[],[],[],[],0,1,[],options);
    function F = wagefunc(x)
        tqt = theta*q(theta,eta);
%         tau = 0.6;
%         TAU1 = tau*((b*x)/tqt); %Take the tax rate as given
        TAU1 = tau;
        sN = exp(-nu_n*aN);
        sB = exp(-nu_b*aB);
        UN = (b*x-d)/(r+tqt); %Given w this is the difference between collecting and non-collecting value functions
%         En = En1(aB,aN,b,chi,d,lambda,pB,pN,phi,r,sB,sN,sigma,tqt,x); 
%         N = N1(aB,aN,b,chi,d,lambda,pB,pN,phi,r,sB,sN,sigma,tqt,x);
%         En_m_N = En-N; %Worker's surplus
%         
%         %Finally, bring in the firm's value functions
% %         J1 = (1./(r+lambda))*(y-x-tauL+lambda.*CN+((sigma*lambda.*(CB-CN))./(r+lambda)));
%         J1 = jn1(c,cb,cn,lambda,pB,pN,r,sB,sN,sigma,TAU1,tauL,x,y);
        
        CB = -TAU1+pB.*sB.*TAU1-(c.*pB).^cb;
        CN = -TAU1+pN.*sN.*TAU1-(c.*pN).^cn; %These are the expected UI costs for firms, given their auditing probabilities
        %Now calculate En0 for a collector:
        AcN = -phi*chi+pN.*(-chi.*aN-sN.*UN); %This is the expected cost of collecting for someone ineligilble for UI
        Eb_m_En = (lambda/(r+lambda+sigma))*(-chi.*(pB.*aB-pN.*aN)+UN.*(pN.*sN-pB.*sB)); %Difference in value functions Eb and En for chi less than chi*_N
        En_m_U = (1/(r+lambda+tqt))*(x.*(1-b)+lambda*(AcN)+sigma.*Eb_m_En); %Difference in En and U value functions
        rEnc_new = x+lambda.*(AcN-En_m_U)+sigma.*Eb_m_En; %The updated En value function
        Nc_new = (1/(r+tqt)).*(d+tqt.*(rEnc_new/r)); %This is the value of N for a collector, given the employed value function
        En_m_N = (rEnc_new./r)-Nc_new; %This is the difference that workers use in bargaining, we are updating it for the next iteration
        
        %Finally, bring in the firm's value functions
        J1 = (1./(r+lambda))*(y-x-tauL+lambda.*CN+((sigma*lambda.*(CB-CN))./(r+lambda)));
        
        %Then examine surpluses
        F = -(J1.^(1-beta)).*(En_m_N.^beta);
    end
end