%This function calculates wage, w1 (always collect) and thus value function for a given chi
function [woptc2,s2opt] = wagechi2(chi,theta,b,d,r,nu_b,phi,tau,cb,c,beta,lambda,sigma,eta,tauL,y,alow)

options = optimoptions('fmincon','Display','off');
x0 = 0.8; %Initial guess for the wage
[woptc2,s2opt] = fmincon(@wagefunc,x0,[],[],[],[],0,1,[],options);
    function F = wagefunc(x)
        %Now we have to calculate the second wage, where workers collect when
        %eligible, but not when ineligible
        tqt = theta*q(theta,eta);
        TAU2 = tau*((b*x)/tqt); %Take the tax rate as given
%         TAU2 = tau;
        UN2 = (b.*x-d)./(r+tqt); %Update the U minus N difference with the new wage
%         aN2 = (1/nu_n)*log((nu_n*UN2)./chi);
%         aN2(aN2<alow) = alow;
%         sN2 = exp(-nu_n*aN2);
%         pN2 = ((sN2*tau).^(1/(cn-1)))/(cn); %Firm's optimal choice of audit probability
%         pN2(pN2>1)=1; %Make sure the probability does not exceed 1
        aB2 = (1/nu_b)*log((nu_b*UN2)./chi);
        if aB2<alow
            aB2 = alow;
        end
%         aB2(aB2<alow) = alow;
        sB2 = exp(-nu_b*aB2);
        pB2 = ((sB2.*TAU2)/(c*cb)).^(1/(cb-1)); %Firm's optimal choice of audit probability
        pB2(pB2>1)=1; %Make sure the probability does not exceed 1
        CB2 = -TAU2+pB2.*sB2.*TAU2-(c.*pB2).^cb;
        Eb_m_En2 = (lambda/(r+lambda+sigma))*(-chi.*(phi+pB2.*aB2)+UN2.*(1-pB2.*sB2)); %This is the difference between value of eligible employment and ineligible employment
        En_m_N2 = (1/(r+lambda+tqt)).*(x-d+sigma.*Eb_m_En2); %Update the difference in utility from En to N
%         rEnc2_new = x-lambda.*En_m_N2; %Finally update the En2 value function
%         En = En2(aB2,b,chi,d,lambda,pB2,phi,r,sB2,sigma,tqt,x);
%         N = N2(aB2,b,chi,d,lambda,pB2,phi,r,sB2,sigma,tqt,x);
%         En_m_N2 = En-N; %Worker surplus
        %Now calculate non-collector value function, as a function of wages: 
        J2 = (1./(r+lambda))*(y-x-tauL+((sigma*lambda.*CB2)./(r+lambda+sigma)));
%         J2 = jn2(c,cb,lambda,pB2,r,sB2,sigma,TAU2,tauL,x,y);
        F = -(J2.^(1-beta)).*(En_m_N2.^beta);
    end
end
