%Given wages, find the lowest W each chi is willing to accept to be
%indifferent between collecting or not
Nw = 100000;
WM = linspace(0.001,0.95,Nw);
UNw1 = (b*WM-d)./(r+tqt);

TAUw = tau*((b*WM)/tqt);
UNw2 = (b*WM-d)/(r+tqt); %Update the U minus N differenchi = chiN-0.0001; %At this point, worker would have been indifferent at original wage
%First order is to deal with the rounding errors and adjust chiN and chiN0
%so the in_diff1 function is properly positive at chiN and is 0 at chiN0

chi = chiN0; %Start here, gamma should be just positive at w1
aNw1 = (1/nu_n)*log((nu_n*UNw1)./chi);
aNw1(aNw1<alow) = alow;
aNw1(aNw1>=50) = 50;
sNw1 = exp(-nu_n*aNw1);
pNw1 = ((sNw1.*TAUw)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
in_diff1 = (UNw1).*(1-pNw1.*sNw1) - chi*(phi+pNw1.*aNw1); %This is the function for chi < chiN
w1p = pchip(CHI,W1,chi);

% Create figure 3a
figure1 = figure;
axes1 = axes('Parent',figure1);
hold(axes1,'on');
plot1 = plot(WM,in_diff1,WM,zeros(1,Nw),'LineWidth',2);
set(plot1(1),'LineStyle','--');
xline(w1p,'Parent',axes1,'LineWidth',2);
ylabel('$\Gamma(w;\chi)$','Interpreter','latex');
xlabel('w');
xlim(axes1,[0 0.8]);
ylim(axes1,[-0.6 0.2]);
set(axes1,'FontSize',12,'TickLabelInterpreter','latex','XTick',...
    [0 0.1 0.2 0.3 0.4 0.4951 0.6 0.7 0.8],'XTickLabel',...
    {'0','0.1','0.2','0.3','0.4','$w^*_1(\chi^*_N)$','0.6','0.7','0.8'})

%Create Figure 3b
chi = chiN;
aNw1 = (1/nu_n)*log((nu_n*UNw1)./chi);
aNw1(aNw1<alow) = alow;
aNw1(aNw1>=50) = 50;
sNw1 = exp(-nu_n*aNw1);
pNw1 = ((sNw1.*TAUw)/(c*cn)).^(1/(cn-1)); %Firm's optimal choice of audit probability
in_diff1 = (UNw1).*(1-pNw1.*sNw1) - chi*(phi+pNw1.*aNw1); %This is the function for chi < chiN
w1p = W1(chiN_i);

% Create figure
figure2 = figure;
axes2 = axes('Parent',figure2);
hold(axes2,'on');
plot2 = plot(WM,in_diff1,WM,zeros(1,Nw),'LineWidth',2);
set(plot2(1),'LineStyle','--');
xline(w1p,'Parent',axes2,'LineWidth',2);
ylabel('$\Gamma(w;\chi)$','Interpreter','latex');
xlabel('w');
xlim(axes2,[0.47 0.51]);
set(axes2,'FontSize',12,'TickLabelInterpreter','latex','XTick',...
    [0.47 0.475 0.48 0.4883 0.495 0.5 0.505 0.51],'XTickLabel',...
    {'0.47','0.475','0.48','$w^*_1(\tilde{\chi}^*_N)$','0.495','0.5','0.505','0.51'});

%Figure 4

%Figure 4b
chi = chiB0; %ChiB*
aBw2 = (1/nu_b)*log((nu_b*UNw2)./chi);
aBw2(aBw2<alow) = alow;
sBw2 = exp(-nu_b*aBw2);
pBw2 = ((sBw2.*TAUw).^(1/(cb-1)))/(c*cb); %Firm's optimal choice of audit probability
pBw2(pB2>1)=1; %Make sure the probability does not exceed 1
in_diff2 = (UNw2).*(1-pBw2.*sBw2) - chi*(phi+pBw2.*aBw2); %This is the function for chi < chiN
w2p = pchip(CHI,W2,chi);

figure3 = figure; %This is Figure 4b
axes3 = axes('Parent',figure3);
hold(axes3,'on');
plot3 = plot(WM,in_diff2,WM,zeros(1,Nw),'LineWidth',2);
set(plot3(1),'LineStyle','--');
xline(w2p,'Parent',axes3,'LineWidth',2);
ylabel('$\Gamma(w;\chi^*_B)$','Interpreter','latex');
xlabel('w');
% xlim(axes3,[0.494 0.4955]);
set(axes3,'FontSize',12,'TickLabelInterpreter','latex','XTick',...
    [0 0.1 0.2 0.3 0.4 0.495 0.6 0.7 0.8 0.9 1],'XTickLabel',...
    {'0','0.1','0.2','0.3','0.4','$w^*_2(\chi^*_B)$','0.6','0.7','0.8','0.9','1'});
hold off

%Figure 4a
chi = chiB; %Tilde ChiB* (This is Figure 4a)
aBw2 = (1/nu_b)*log((nu_b*UNw2)./chi);
aBw2(aBw2<alow) = alow;
sBw2 = exp(-nu_b*aBw2);
pBw2 = ((sBw2.*TAUw).^(1/(cb-1)))/(c*cb); %Firm's optimal choice of audit probability
pBw2(pB2>1)=1; %Make sure the probability does not exceed 1
in_diff2 = (UNw2).*(1-pBw2.*sBw2) - chi*(phi+pBw2.*aBw2); %This is the function for chi < chiN
w2p = pchip(CHI,W2,chi);

% Create figure
figure4 = figure;
axes4 = axes('Parent',figure4);
hold(axes4,'on');
plot4 = plot(WM,in_diff2,WM,zeros(1,Nw),'LineWidth',2);
set(plot4(1),'LineStyle','--');
xline(w2p,'Parent',axes4,'LineWidth',2);
ylabel('$\Gamma(w;\chi)$','Interpreter','latex');
xlabel('w');
xlim(axes4,[0.494 0.4955]);
set(axes4,'FontSize',12,'TickLabelInterpreter','latex','XTickLabel',...
    {'0.494','0.4945','$w^*_2(\tilde{\chi}^*_B)$','0.4955'});
hold off

%First get wages inbetween chiN and chiN0
N_chin = 10;
CHI_Np = linspace(chiN,chiN0,N_chin);
WtN = zeros(1,N_chin);
WsN = pchip(CHI,W1,CHI_Np); %Original wage for comparison
chi = CHI_Np(1);
aNw1 = (1/nu_n)*log((nu_n*UNw1)./chi);
aNw1(aNw1<alow) = alow;
sNw1 = exp(-nu_n*aNw1);
pNw1 = ((sNw1.*TAUw).^(1/(cn-1)))/(c*cn); %Firm's optimal choice of audit probability
in_diff1 = (UNw1).*(1-pNw1.*sNw1) - chi*(phi+pNw1.*aNw1); %This is the function for chi < chiN
ind_w1A = find(in_diff1>=0,1,'last'); %Find where this is eventually negative and the worker no longer wants to collect
if isempty(ind_w1A)==1 %This means there is no possible wage
    wthr = WsN(j);
else
    wthr = WM(ind_w1A);
end
WtN(1) = wthr;
WtN(N_chin) = WsN(N_chin); %Effectively the same wage here, as the change is only infenitesimal at this point
WtN(2:(N_chin-1)) = pchip([chiN chiN0],[WtN(1) WtN(N_chin)],CHI_Np(2:(N_chin-1)));

figure;
axes5 = axes;
hold(axes5,'on');
plot5 = plot(CHI_Np,WtN,CHI_Np,WsN,'LineWidth',2);
set(plot5(1),'DisplayName','$\tilde{w}_{1}(\chi)$','LineStyle','--');
set(plot5(2),'DisplayName','$w^{*}_{1}(\chi)$');
ylabel('Wage');
xlabel('\chi');
xlim([chiN chiN0]);
box(axes5,'on');
set(axes5,'FontSize',12);
legend5 = legend(axes5,'show');
set(legend5,...
    'Position',[0.652677822432341 0.773094785118858 0.204465034710516 0.0907142843518939],...
    'Interpreter','latex',...
    'FontSize',14);
hold off

%Now do the same for chiB
N_chib = 10;
CHI_Bp = linspace(chiB,chiB0,10);
WtB = zeros(1,N_chib);
WsB = pchip(CHI,W2,CHI_Bp);
chi = CHI_Bp(1);
aBw2 = (1/nu_b)*log((nu_b*UNw2)./chi);
aBw2(aBw2<alow) = alow;
sBw2 = exp(-nu_b*aBw2);
pBw2 = ((sBw2.*TAUw).^(1/(cb-1)))/(c*cb); %Firm's optimal choice of audit probability
pBw2(pB2>1)=1; %Make sure the probability does not exceed 1
in_diff2 = (UNw2).*(1-pBw2.*sBw2) - chi*(phi+pBw2.*aBw2); 
ind_w2A = find(in_diff2>=0,1,'first');
if isempty(ind_w2A)==1
    wthr = WsB(j);
else
    wthr = WM(ind_w2A);
end
WtB(1) = wthr;
WtB(N_chib) = WsB(N_chib);
WtB(2:(N_chib-1)) = pchip([chiB chiB0],[WtB(1) WsB(N_chib)],CHI_Bp(2:(N_chib-1)));

figure;
axes1 = axes;
hold(axes1,'on');
plot1 = plot(CHI_Bp,WtB,CHI_Bp,WsB,'LineWidth',2);
set(plot1(1),'DisplayName','$\tilde{w}_{2}(\chi)$','LineStyle','--');
set(plot1(2),'DisplayName','$w^{*}_{2}(\chi)$');
ylabel('Wage');
xlabel('\chi');
xlim([chiB chiB0]);
box(axes1,'on');
set(axes1,'FontSize',12);
legend1 = legend(axes1,'show');
set(legend1,...
    'Position',[0.652677822432341 0.773094785118858 0.204465034710516 0.0907142843518939],...
    'Interpreter','latex',...
    'FontSize',14);
hold off

%Now make a wage function over CHIF
W1F = pchip(CHI,W1,CHIF);
W2F = pchip(CHI,W2,CHIF);
W3F = pchip(CHI,W3,CHIF);
Wage = [W1F(1:chiN_iF) W2F(chiN_iF+1:chiB_iF) WtB(2:length(WtB)) W3F(chiB_iF0+1:length(CHIF))];
Wage0 = [W1F(1:chiN_iF) W2F(chiN_iF+1:chiB_iF) W3F(chiB_iF+1:length(CHIF))];

%Plots
%First up close of w1 and wtilde1
CHIN_IBNB = linspace(chiN0,chiN0+0.02,10);
CHIN_plot = [CHIF(1:chiN_iF) CHI_Np CHIN_IBNB];
W2_IB_plot = pchip(CHI,W2,CHIN_IBNB);
W1_plot = [W1F(1:chiN_iF) WtN W2_IB_plot];
%Now the upclose of W2
CHIB_IBB = linspace(chiB0,chiB0+0.02,10);
CHIB_plot = [CHIN_IBNB CHIF(chiN_iF+1:chiB_iF) CHI_Bp CHIB_IBB];
W3_IB_plot = pchip(CHI,W3,CHIB_IBB);
W2_plot = [W2_IB_plot W2F(chiN_iF+1:chiB_iF) WtB W3_IB_plot];
%Now add a bit of W3 for a complete picture
W3F = pchip(CHI,W3,CHIF); %Interpolate w3 over a finer grid
CHI3_plot = linspace(chiB0+0.05,2,50);
CHI_ALL = [CHIN_plot CHIB_plot CHI3_plot];
W3_plot = pchip(CHIF,W3F,CHI3_plot);
WALL_plot = [W1_plot W2_plot W3_plot];
plot(CHI_ALL,WALL_plot); %This is Figure 6

%Translate these into pj's and sj's
UBt = (b*WtB-d)./(r+tqt); %This should be the relevant value functions for wages
TAUBt = tau*((b*WtB)/tqt); %Corresponding tax for firm
aBt = (1/nu_b)*log((nu_b*UBt)./chi);
aBt(aBt<alow) = alow;
sBt = exp(-nu_b*aBt);
pBt = ((sBt.*TAUBt).^(1/(cb-1)))/(c*cb); %Firm's optimal choice of audit probability
pBt(pBt>1)=1; %Make sure the probability does not exceed 

UNt = (b*WtN-d)./(r+tqt); %This should be the relevant value functions for wages
TAUNt = tau*((b*WtN)/tqt); %Corresponding tax for firm
aNt = (1/nu_n)*log((nu_n*UNt)./chi);
aNt(aNt<alow) = alow;
sNt = exp(-nu_n*aNt);
pNt = ((sNt.*TAUNt).^(1/(cn-1)))/(c*cn); %Firm's optimal choice of audit probability
pNt(pNt>1)=1; %Make sure the probability does not exceed 

%Going to do something similar for pJ and sJ plots
pBF = pchip(CHI,pB,CHIF);
sBF = pchip(CHI,sB,CHIF);
pB2F = pchip(CHI,pB2,CHIF);
sB2F = pchip(CHI,sB2,CHIF);
pNF = pchip(CHI,pN0,CHIF);
sNF = pchip(CHI,sN0,CHIF);
pN2F = pchip(CHI,pN2,CHIF);
sN2F = pchip(CHI,sN2,CHIF);

%The above gives p's over the same range of chi we did wages; no change to
%pB2 is necessary around chiB, because the wage changes are so small.
%Now construct vectors to plot pN and pB
pB1p = pBF(1:chiN_iF); 
sB1p = sBF(1:chiN_iF);
pB2p = pB2F(chiN_iF0:length(CHIF));
sB2p = sB2F(chiN_iF0:length(CHIF));
CHI_pp = [CHIF(1:chiN_iF) CHI_Np CHIF(chiN_iF0:length(CHIF))];
pB_p = [pB1p pBt pB2p];
sB_p = [sB1p sBt sB2p];
pN1p = pNF(1:chiN_iF);
sN1p = sNF(1:chiN_iF);
pN2p = pN2F(chiN_iF0:length(CHIF));
sN2p = sN2F(chiN_iF0:length(CHIF));
pN_p = [pN1p pNt pN2p];
sN_p = [sN1p sNt sN2p];

figure %This is Figure 7a
plot(CHI_pp,pB_p);
xlim([0,0.1]);
ylim([0,0.0205]);

%This is Figure 7b
figure
plot(CHI_pp,pN_p);
xlim([0,0.1]);
ylim([0,0.8]);

%This is Figure 7c
figure
plot(CHI_pp,sB_p);
xlim([0,0.07]);
ylim([0,0.025]);

%This is Figure 7d
figure
plot(CHI_pp,sN_p);
xlim([0,0.07]);
ylim([0,1]);